---
title: Symbol.match
slug: Web/JavaScript/Reference/Global_Objects/Symbol/match
tags:
  - ECMAScript 2015
  - JavaScript
  - Property
  - Symbol
---
<div>{{JSRef}}</div>

<p>The <code><strong>Symbol.match</strong></code> well-known symbol specifies the matching of a regular expression against a string. This function is called by the {{jsxref("String.prototype.match()")}} method.</p>

<div>{{EmbedInteractiveExample("pages/js/symbol-match.html")}}</div>

<h2 id="Description">Description</h2>

<p>This function is also used to identify if objects have the behavior of regular expressions. For example, the methods {{jsxref("String.prototype.startsWith()")}}, {{jsxref("String.prototype.endsWith()")}} and {{jsxref("String.prototype.includes()")}}, check if their first argument is a regular expression and will throw a {{jsxref("TypeError")}} if they are. Now, if the <code>match</code> symbol is set to <code>false</code> (or a <a href="/en-US/docs/Glossary/Falsy">Falsy</a> value), it indicates that the object is not intended to be used as a regular expression object.</p>

<p>{{js_property_attributes(0,0,0)}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="Disabling_the_isRegExp_check">Disabling the <code>isRegExp</code> check</h3>

<p>The following code will throw a {{jsxref("TypeError")}}:</p>

<pre class="brush: js">'/bar/'.startsWith(/bar/);

// Throws TypeError, as /bar/ is a regular expression
// and Symbol.match is not modified.</pre>

<p>However, if you set <code>Symbol.match</code> to <code>false</code>, the <code>isRegExp</code> check (that uses the <code>match</code> property) will indicate that the object is not a regular expression object. The methods <code>startsWith</code> and <code>endsWith</code> won't throw a <code>TypeError</code> as a consequence.</p>

<pre class="brush: js">var re = /foo/;
re[Symbol.match] = false;
'/foo/'.startsWith(re); // true
'/baz/'.endsWith(re);   // false
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-symbol.match', 'Symbol.match')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Symbol.match")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Symbol.replace")}}</li>
 <li>{{jsxref("Symbol.search")}}</li>
 <li>{{jsxref("Symbol.split")}}</li>
 <li>{{jsxref("RegExp.@@match", "RegExp.prototype[@@match]()")}}</li>
</ul>
